#include <Xm/Xm.h>
#include <Xm/RowColumn.h>
#include <Xm/LabelG.h>
#include <Xm/ToggleB.h>
#include <Xm/PushBG.h>
#include <Xm/Text.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>
#include "../modules/control.h"
#include "global.h"

void c_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  Widget toplevel, shell, rowcol;
  Widget toglow, toghigh, w, wsample;
  Widget ad0, ad1;
  static Widget *gray;
  int    i;
  char   title[80], text[80];
  static calib  *cal;

  void ok_cb(Widget w, XtPointer client_data, XtPointer call_data);
  void cancel_cb(Widget w, XtPointer client_data, XtPointer call_data);
  void sample_cb(Widget w, XtPointer client_data, XtPointer call_data);
  void togl_cb(Widget w, XtPointer client_data, XtPointer call_data);
  void togh_cb(Widget w, XtPointer client_data, XtPointer call_data);
  void rwl_cb(Widget w, XtPointer client_data, XtPointer call_data);
  void adl_cb(Widget w, XtPointer client_data, XtPointer call_data);
  void rwh_cb(Widget w, XtPointer client_data, XtPointer call_data);
  void adh_cb(Widget w, XtPointer client_data, XtPointer call_data);

  if (!reg.recon) {
    if (!cal) cal=new calib;
    if (!gray) gray=new Widget[4];
    i=(int) client_data;
    *cal=ch[i].cal;
    sprintf(title, "Calibrate Channel %d", i+1);
    
    toplevel=XtParent(drawing_a);
    while (!XtIsTopLevelShell(toplevel)) toplevel=XtParent(toplevel);
    shell= XtVaCreatePopupShell("CalibrateForm",
				topLevelShellWidgetClass, toplevel,
				XtNtitle, title, NULL);

    rowcol=XtVaCreateManagedWidget("rowcol",
				   xmRowColumnWidgetClass, shell,
				   XmNorientation, XmHORIZONTAL,
				   XmNpacking, XmPACK_COLUMN,
				   XmNnumColumns, 4,
				   NULL);

    XtVaCreateManagedWidget("dummy", xmLabelGadgetClass, rowcol,
			    XmNlabelString, XmStringCreateLocalized(" "),
			    NULL);
    XtVaCreateManagedWidget("label", xmLabelGadgetClass, rowcol,
			    XmNlabelString, XmStringCreateLocalized("RW values"),
			    NULL);
    XtVaCreateManagedWidget("label", xmLabelGadgetClass, rowcol,
			    XmNlabelString, XmStringCreateLocalized("AD values"),
			    NULL);

    toglow=XtVaCreateManagedWidget("low: ", xmToggleButtonWidgetClass, rowcol,
			      NULL);
    XmToggleButtonSetState(toglow,True, False);

    w=XtVaCreateManagedWidget("text", xmTextWidgetClass, rowcol,
			      XmNcolumns, 15,
			      NULL);
    sprintf(text,"%f",cal->rw_low);
    XmTextSetString(w, text);
    XtAddCallback(w, XmNlosingFocusCallback, rwl_cb, cal);

    ad0=XtVaCreateManagedWidget("text", xmTextWidgetClass, rowcol,
				XmNcolumns, 15,
				XmNuserData, i,
				NULL);
    sprintf(text,"%d",cal->ad_low);
    XmTextSetString(ad0, text);
    XtAddCallback(ad0, XmNlosingFocusCallback, adl_cb, cal);

    toghigh=XtVaCreateManagedWidget("high: ", xmToggleButtonWidgetClass, rowcol,
				    NULL);
    XmToggleButtonSetState(toghigh,False, False);
    XtAddCallback(toghigh, XmNvalueChangedCallback, togh_cb, toglow);
    XtAddCallback(toglow, XmNvalueChangedCallback, togl_cb, toghigh);

    w=XtVaCreateManagedWidget("text", xmTextWidgetClass, rowcol,
			      XmNcolumns, 15,
			      NULL);
    sprintf(text,"%f",cal->rw_high);
    XmTextSetString(w, text);
    XtAddCallback(w, XmNlosingFocusCallback, rwh_cb, cal);

    ad1=XtVaCreateManagedWidget("text", xmTextWidgetClass, rowcol,
				XmNcolumns, 15,
				XmNuserData, i,
				NULL);
    sprintf(text,"%d",cal->ad_high);
    XmTextSetString(ad1, text);
    XtAddCallback(ad1, XmNlosingFocusCallback, adh_cb, cal);
    XtVaSetValues(toglow, XmNuserData, ad0, NULL);
    XtVaSetValues(toghigh, XmNuserData, ad1, NULL);
    gray[0]=toglow; gray[1]=toghigh;

    wsample=XtVaCreateManagedWidget("button", xmPushButtonGadgetClass, rowcol,
				    XmNlabelString, XmStringCreateLocalized("Sample on"),
				    XmNalignment, XmALIGNMENT_CENTER,
				    XmNuserData, cal,
				    NULL);
    w=XtVaCreateManagedWidget("button", xmPushButtonGadgetClass, rowcol,
			      XmNlabelString, XmStringCreateLocalized("Ok"),
			      XmNalignment, XmALIGNMENT_CENTER,
			      XmNuserData, i,
			      NULL);
    XtAddCallback(w, XmNactivateCallback, ok_cb, cal);
    gray[2]=w;
    w=XtVaCreateManagedWidget("button", xmPushButtonGadgetClass, rowcol,
			      XmNlabelString, XmStringCreateLocalized("Cancel"),
			      XmNalignment, XmALIGNMENT_CENTER,
			      NULL);
    XtAddCallback(w, XmNactivateCallback, cancel_cb, NULL);
    gray[3]=w;
    XtAddCallback(wsample, XmNactivateCallback, sample_cb, gray);

    XtPopup(shell, XtGrabNone);
  }
}

/* ......................................... */
/* ...   C A L L B A C K S               ... */
/* ......................................... */

void ok_cb(Widget w, XtPointer client_data, XtPointer call_data) {
  calib *cal;
  int   i, j;
  float m, b;
  extern void clearscreen(Window window);

  XtVaGetValues(w, XmNuserData, &i, NULL);
  cal=(calib *)client_data;
  ch[i].cal.rw_low=cal->rw_low;
  ch[i].cal.ad_low=cal->ad_low;
  ch[i].cal.rw_high=cal->rw_high;
  ch[i].cal.ad_high=cal->ad_high;
  // set calibration for max, mean, min in derived channels;
  for (j=1; j<=3; j++) { 
    dch[i].ch[j].cal.rw_low=cal->rw_low;
    dch[i].ch[j].cal.ad_low=cal->ad_low;
    dch[i].ch[j].cal.rw_high=cal->rw_high;
    dch[i].ch[j].cal.ad_high=cal->ad_high;
  }
  // set calibration for ampli;
  m=(cal->rw_high-cal->rw_low)/(cal->ad_high-cal->ad_low);
  b=cal->rw_high-m*cal->ad_high;
  dch[i].ch[4].cal.rw_low=0;
  dch[i].ch[4].cal.rw_high=m*4095;
  dch[i].ch[4].cal.ad_low=0;
  dch[i].ch[4].cal.ad_high=4095;
  
  while(w && !XtIsWMShell(w)) w=XtParent(w);
  XtPopdown(w);
  XtDestroyWidget(w);
  clearscreen(XtWindow(drawing_a));
}
void cancel_cb(Widget w, XtPointer client_data, XtPointer call_data) {
  while(w && !XtIsWMShell(w)) w=XtParent(w);
  XtPopdown(w);
  XtDestroyWidget(w);
}
void sample_cb(Widget w, XtPointer client_data, XtPointer call_data) {
  static short rec_on=0;
  Widget ad0, ad1, toglow, toghigh, wok, wcancel;
  int    i, sr, chan;
  char   c, p, *text;
  Widget *gray;
  calib  *cal;
  struct my_msg_struct msg;

  Boolean calrec(XtPointer client_data);

  gray=(Widget *)client_data;
  XtVaGetValues(w, XmNuserData, &cal, NULL);
  toglow=gray[0];
  toghigh=gray[1];
  wok=gray[2];
  wcancel=gray[3];
  XtVaGetValues(toglow, XmNuserData, &ad0, NULL);
  XtVaGetValues(toghigh, XmNuserData, &ad1, NULL);
  XtVaGetValues(ad0, XmNuserData, &chan, NULL);
  if (rec_on) {
    XtVaSetValues(w, XmNlabelString, XmStringCreateLocalized("Sample on"), NULL);
    for (i=0; i<4; i++) XtSetSensitive(gray[i], True);
    msg.command=STOP_TASK; msg.value=0;
    write(fd8, &msg, sizeof(msg));
    msg.command=SET_SR; msg.value=1;
    write(fd8, &msg, sizeof(msg));
    msg.command=SET_CH; msg.value=0;
    write(fd8, &msg, sizeof(msg));
    msg.command=SET_POL; msg.value=0;
    write(fd8, &msg, sizeof(msg));
    XtRemoveWorkProc(work_id);
    if (XmToggleButtonGetState(toglow)) {
      text=XmTextGetString(ad0);
      cal->ad_low=atoi(text);
      XtFree(text);
    }
    else {
      text=XmTextGetString(ad1);
      cal->ad_high=atoi(text);
      XtFree(text);
    }
    rec_on=0;
  }
  else {
    XtVaSetValues(w, XmNlabelString, XmStringCreateLocalized("Sample off"), NULL);
    for (i=0; i<4; i++) XtSetSensitive(gray[i], False);
    msg.command=SET_SR; msg.value=5;
    write(fd8, &msg, sizeof(msg));
    p=(0);
    if (chan==0) {
      c=(1);
      if (ch[0].polarity) p=(1);
    }
    if (chan==1) {
      c=(2);
      if (ch[1].polarity) p=(2);
    }
    if (chan==2) {
      c=(4);
      if (ch[2].polarity) p=(4);
    }
    if (chan==3) {
      c=(8);
      if (ch[3].polarity) p=(8);
    }
    if (chan==4) {
      c=(16);
      if (ch[4].polarity) p=(16);
    }
    if (chan==5) {
      c=(32);
      if (ch[5].polarity) p=(32);
    }
    if (chan==6) {
      c=(64);
      if (ch[6].polarity) p=(64);
    }
    if (chan==7) {
      c=(128);
      if (ch[7].polarity) p=(128);
    }
    msg.command=SET_CH; msg.value=(int)c;
    write(fd8, &msg, sizeof(msg));
    msg.command=SET_POL; msg.value=(int)p;
    write(fd8, &msg, sizeof(msg));
    msg.command=START_TASK; msg.value=0;
    write(fd8, &msg, sizeof(msg));
    work_id=XtAppAddWorkProc(app, calrec, XmToggleButtonGetState(toglow) ? ad0 : ad1);
    rec_on=1;
  }
}

void togl_cb(Widget w, XtPointer client_data, XtPointer call_data) {
  Widget togh;

  togh=(Widget) client_data;
  if (XmToggleButtonGetState(w) && XmToggleButtonGetState(togh)) {
    XmToggleButtonSetState(togh, False, False);
  }
  else XmToggleButtonSetState(w, !XmToggleButtonGetState(w), False);
}
void togh_cb(Widget w, XtPointer client_data, XtPointer call_data) {
  Widget togl;

  togl=(Widget) client_data;
  if (XmToggleButtonGetState(w) && XmToggleButtonGetState(togl)) {
    XmToggleButtonSetState(togl, False, False);
  }
  else XmToggleButtonSetState(w, !XmToggleButtonGetState(w), False);
}

void rwl_cb(Widget w, XtPointer client_data, XtPointer call_data) {
  calib *cal=(calib *) client_data;
  char  *text = XmTextGetString(w);
  char  t[80];

  cal->rw_low=atof(text);
  sprintf(t,"%f",cal->rw_low);
  XmTextSetString(w,t);

  XtFree(text);
}
void adl_cb(Widget w, XtPointer client_data, XtPointer call_data) {
  calib *cal=(calib *) client_data;
  char  *text = XmTextGetString(w);
  char  t[80];

  cal->ad_low=atoi(text);
  sprintf(t,"%d",cal->ad_low);
  XmTextSetString(w,t);

  XtFree(text);
}
void rwh_cb(Widget w, XtPointer client_data, XtPointer call_data) {
  calib *cal=(calib *) client_data;
  char  *text = XmTextGetString(w);
  char  t[80];

  cal->rw_high=atof(text);
  sprintf(t,"%f",cal->rw_high);
  XmTextSetString(w,t);

  XtFree(text);
}
void adh_cb(Widget w, XtPointer client_data, XtPointer call_data) {
  calib *cal=(calib *) client_data;
  char  *text = XmTextGetString(w);
  char  t[80];

  cal->ad_high=atoi(text);
  sprintf(t,"%d",cal->ad_high);
  XmTextSetString(w,t);

  XtFree(text);
}

Boolean calrec(XtPointer client_data) {
  Widget ad;
  int    ch, wert;
  char   *w, buf[2], text[30];

  ad=(Widget) client_data;
  XtVaGetValues(ad, XmNuserData, &ch, NULL);

  w=(char*) &wert;
  if (read(fd[ch], (char *) buf, 2)>0) {
    wert=0;
    *w=buf[0]; *(w+1)=buf[1];
    sprintf(text, "%d", wert);
    XmTextSetString(ad, text);
  }

  return(0);
}
